// HTCCamera1.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "HTCCamera1.h"
#include <windows.h>
#include <commctrl.h>

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

HANDLE hCam = 0;

HTCCAMERA1_API int Camera_Init(DWORD dw1, DWORD *dw2)
{
   // assume error (TorchButton expects 0 : OK)
   if (dw2)
   {
      *dw2 = 1;
   }

   if (dw1 == 1 && dw2)
   {
      hCam = CreateFile(
         L"CAM1:",
         GENERIC_WRITE,
         FILE_SHARE_READ | FILE_SHARE_WRITE,
         NULL,
         OPEN_EXISTING,
         FILE_ATTRIBUTE_NORMAL,
         NULL
      );

      if (hCam == INVALID_HANDLE_VALUE)
      {
         hCam = 0;
      }
      else
      {
         *dw2 = 0;
      }
   }
   return 0;
}
HTCCAMERA1_API int Camera_Deinit()
{
   if (hCam)
   {
      CloseHandle(hCam);
      hCam = 0;
   }
   return 0;
}
HTCCAMERA1_API int Camera_FlashLight(DWORD dwValue)
{
   if (hCam)
   {
      // by default switch off the flash
      unsigned char signal = 0;

      // switch on
      if (dwValue == 1)
      {
         signal = 1;
      }

      // send command
      DeviceIoControl(hCam, 0x777, (LPVOID)&signal, 1, 0, 0, 0, 0);
   }
   return 0;
}

